FI N-body/SPH code & AMUSE interface

FI is a parallel TreeSPH code for galaxy simulations. Extensively 
rewritten, extended and parallelized it is a development from code from 
Jeroen Gerritsen and Roelof Bottema, which itself goes back to Treesph. 

Note that some features are not working atm. These may be fixed in the 
future. (and I will think of a better name)

The relevant references are:

Hernquist & Katz, 1989, ApJS 70, 419
Gerritsen & Icke, 1997, A&A 325, 972
Pelupessy, van der Werf & Icke, 2004, A&A 422, 55
Pelupessy, PhD thesis 2005, Leiden Observatory

! This file contains routines to make a visualization of a nbody simulation
! it is self contained and could be called from a running simulation.
! the data is passed through common blocks
 
!


module view_modifier

! This module provides facilities to modify the view in an OpenGL window.
! The mouse buttons and keyboard arrow keys can be used to zoom, pan,
! rotate and change the scale.  A menu or submenu can be used to select which
! buttons perform which function and to reset the view to the initial settings.
! This is limited to one window.

! William F. Mitchell
! william.mitchell@nist.gov
! Mathematical and Computational Sciences Division
! National Institute of Standards and Technology
! April, 1998

! To use this module:
!
! 1) put a USE view_modifier statement in any program unit that calls a
!    procedure in this module
!
! 2) set the initial operation assignments, view and scale below the
!    "Initial configuration" comment below
!
! 3) call view_modifier_init after glutCreateWindow
!    This is a function that returns integer(kind=glcint) menuid.  The menuid
!    is the ID returned by glutCreateMenu.  You can either use the view_modifier
!    menu as your menu by calling glutAttachMenu immediately after
!    view_modifier_init, as in
!       menuid = view_modifier_init()
!       call glutAttachMenu(GLUT_RIGHT_BUTTON)
!    or by using the menuid to attach a submenu to your own menu, as in
!       call glutAddSubMenu("View Modifier",menuid)
!
! 4) in any callback functions that update the display, put
!       call reset_view
!    as the first executable statement
!
! Note that view_modifier_init sets the callback functions for glutMouseFunc,
! glutMotionFunc and glutSpecialFunc, so don't call these yourself
!
! The menu allows you to select what operation is attached to the left and
! middle mouse buttons and arrow keys, reset to the initial view, and quit.
! The right mouse button should be used for the menu.

use opengl_gl
use opengl_glu
use opengl_glut
implicit none
private
public :: view_modifier_init, reset_view
private :: ZOOM, PAN, ROTATE, SCALEX, SCALEY, SCALEZ, RESET, QUIT, &
           PI, &
           left_button_func, middle_button_func, arrow_key_func, &
           init_lookat, init_lookfrom, &
           init_xscale_factor, init_yscale_factor, init_zscale_factor, &
           angle, shift, xscale_factor, yscale_factor, zscale_factor, &
           moving_left, moving_middle, begin_left, begin_middle, &
           cart2sphere, sphere2cart, cart3D_plus_cart3D, cart3D_minus_cart3D, &
           reset_to_init, mouse, motion, arrows, &
           menu_handler, set_left_button, set_middle_button, set_arrow_keys

integer(kind=glcint), parameter :: ZOOM = 1, PAN = 2, ROTATE = 3, SCALEX = 4, &
                      SCALEY = 5, SCALEZ = 6
integer(kind=glcint), parameter :: RESET = 10, QUIT = 11
real(kind=gldouble), parameter :: PI = 3.141592653589793_gldouble

type, private :: cart2D ! 2D cartesian coordinates
   real(kind=gldouble) :: x, y
end type cart2D

type, private :: cart3D ! 3D cartesian coordinates
   real(kind=gldouble) :: x, y, z
end type cart3D

type, private :: sphere3D ! 3D spherical coordinates
   real(kind=gldouble) :: theta, phi, rho
end type sphere3D

type(cart2D), save :: angle
type(cart3D), save :: shift
real(kind=gldouble), save :: xscale_factor, yscale_factor, zscale_factor
logical, save :: moving_left, moving_middle
type(cart2D), save :: begin_left, begin_middle

interface operator(+)
   module procedure cart3D_plus_cart3D
end interface
interface operator(-)
   module procedure cart3D_minus_cart3D
end interface

! ------- Initial configuration -------

! Set the initial operation performed by each button and the arrow keys.
! The operations are ZOOM, PAN, ROTATE, SCALEX, SCALEY, and SCALEZ

integer, save ::   left_button_func = ROTATE, &
                 middle_button_func = ZOOM, &
                     arrow_key_func = PAN

! Set the initial view as the point you are looking at, the point you are
! looking from, and the scale factors

type(cart3D), parameter :: &
     init_lookat = cart3D(0.0_gldouble, 0.0_gldouble, 0.0_gldouble), &
   init_lookfrom = cart3D(6.0_gldouble, -12.0_gldouble, 3.0_gldouble)

real(kind=gldouble), save:: &
   init_xscale_factor = 1.0_gldouble, &
   init_yscale_factor = 1.0_gldouble, &
   init_zscale_factor = 1.0_gldouble

! -------- end of Initial configuration ------

contains

!          -------------
subroutine reset_to_init
!          -------------

! This resets the view to the initial configuration

type(sphere3D) :: slookfrom

slookfrom = cart2sphere(init_lookfrom-init_lookat)
angle%x = -180.0_gldouble*slookfrom%theta/PI - 90.0_gldouble
angle%y = -180.0_gldouble*slookfrom%phi/PI
shift%x = 0.0_gldouble
shift%y = 0.0_gldouble
shift%z = -slookfrom%rho
xscale_factor = init_xscale_factor
yscale_factor = init_yscale_factor
zscale_factor = init_zscale_factor

 call glutPostRedisplay

return
end subroutine reset_to_init

!          ----------
subroutine reset_view
!          ----------

! This routine resets the view to the current orientation and scale

 call glMatrixMode(GL_MODELVIEW)
 call glPopMatrix
 call glPushMatrix
 call glTranslated(shift%x, shift%y, shift%z)
 call glRotated(angle%x, 0.0_gldouble, 0.0_gldouble, 1.0_gldouble)
 call glRotated(angle%y, cos(PI*angle%x/180.0_gldouble), &
               -sin(PI*angle%x/180.0_gldouble), 0.0_gldouble)
 call glTranslated(-init_lookat%x, -init_lookat%y, -init_lookat%z)
 call glScaled(xscale_factor,yscale_factor,zscale_factor)

return
end subroutine reset_view

!          -----
subroutine mouse(button, state, x, y)
!          -----
integer(kind=glcint), intent(in out) :: button, state, x, y

! This gets called when a mouse button changes
 
  if (button == GLUT_LEFT_BUTTON .and. state == GLUT_DOWN) then
    moving_left = .true.
    begin_left = cart2D(x,y)
  endif
  if (button == GLUT_LEFT_BUTTON .and. state == GLUT_UP) then
    moving_left = .false.
  endif
  if (button == GLUT_MIDDLE_BUTTON .and. state == GLUT_DOWN) then
    moving_middle = .true.
    begin_middle = cart2D(x,y)
  endif
  if (button == GLUT_MIDDLE_BUTTON .and. state == GLUT_UP) then
    moving_middle = .false.
  endif
end subroutine mouse

!          ------
subroutine motion(x, y)
!          ------
integer(kind=glcint), intent(in out) :: x, y

! This gets called when the mouse moves

integer :: button_function
type(cart2D) :: begin
real(kind=gldouble) :: factor

! Determine and apply the button function

if (moving_left) then
   button_function = left_button_func
   begin = begin_left
else if(moving_middle) then
   button_function = middle_button_func
   begin = begin_middle
end if

select case(button_function)
case (ZOOM)
   if (y < begin%y) then
      factor = 1.0_gldouble/(1.0_gldouble + .002_gldouble*(begin%y-y))
   else if (y > begin%y) then
      factor = 1.0_gldouble + .002_gldouble*(y-begin%y)
   else
      factor = 1.0_gldouble
   end if
   shift%z = factor*shift%z
case (PAN)
   shift%x = shift%x + .01*(x - begin%x)
   shift%y = shift%y - .01*(y - begin%y)
case (ROTATE)
   angle%x = angle%x + (x - begin%x)
   angle%y = angle%y + (y - begin%y)
case (SCALEX)
   if (y < begin%y) then
      factor = 1.0_gldouble + .002_gldouble*(begin%y-y)
   else if (y > begin%y) then
      factor = 1.0_gldouble/(1.0_gldouble + .002_gldouble*(y-begin%y))
   else
      factor = 1.0_gldouble
   end if
   xscale_factor = xscale_factor * factor
case (SCALEY)
   if (y < begin%y) then
      factor = 1.0_gldouble + .002_gldouble*(begin%y-y)
   else if (y > begin%y) then
      factor = 1.0_gldouble/(1.0_gldouble + .002_gldouble*(y-begin%y))
   else
      factor = 1.0_gldouble
   end if
   yscale_factor = yscale_factor * factor
case (SCALEZ)
   if (y < begin%y) then
      factor = 1.0_gldouble + .002_gldouble*(begin%y-y)
   else if (y > begin%y) then
      factor = 1.0_gldouble/(1.0_gldouble + .002_gldouble*(y-begin%y))
   else
      factor = 1.0_gldouble
   end if
   zscale_factor = zscale_factor * factor
end select

! update private variables and redisplay

if (moving_left) then
   begin_left = cart2D(x,y)
else if(moving_middle) then
   begin_middle = cart2D(x,y)
endif

if (moving_left .or. moving_middle) then
   call glutPostRedisplay
endif

return
end subroutine motion

!          ------
subroutine arrows(key, x, y)
!          ------
integer(glcint), intent(in out) :: key, x, y

! This routine handles the arrow key operations

real(kind=gldouble) :: factor

select case(arrow_key_func)
case(ZOOM)
   select case(key)
   case(GLUT_KEY_DOWN)
      factor = 1.0_gldouble + .02_gldouble
   case(GLUT_KEY_UP)
      factor = 1.0_gldouble/(1.0_gldouble + .02_gldouble)
   case default
      factor = 1.0_gldouble
   end select
   shift%z = factor*shift%z
case(PAN)
   select case(key)
   case(GLUT_KEY_LEFT)
      shift%x = shift%x - .02
   case(GLUT_KEY_RIGHT)
      shift%x = shift%x + .02
   case(GLUT_KEY_DOWN)
      shift%y = shift%y - .02
   case(GLUT_KEY_UP)
      shift%y = shift%y + .02
   end select
case(ROTATE)
   select case(key)
   case(GLUT_KEY_LEFT)
      angle%x = angle%x - 1.0_gldouble
   case(GLUT_KEY_RIGHT)
      angle%x = angle%x + 1.0_gldouble
   case(GLUT_KEY_DOWN)
      angle%y = angle%y + 1.0_gldouble
   case(GLUT_KEY_UP)
      angle%y = angle%y - 1.0_gldouble
   end select
case(SCALEX)
   select case(key)
   case(GLUT_KEY_DOWN)
      factor = 1.0_gldouble/(1.0_gldouble + .02_gldouble)
   case(GLUT_KEY_UP)
      factor = 1.0_gldouble + .02_gldouble
   case default
      factor = 1.0_gldouble
   end select
   xscale_factor = xscale_factor * factor
case(SCALEY)
   select case(key)
   case(GLUT_KEY_DOWN)
      factor = 1.0_gldouble/(1.0_gldouble + .02_gldouble)
   case(GLUT_KEY_UP)
      factor = 1.0_gldouble + .02_gldouble
   case default
      factor = 1.0_gldouble
   end select
   yscale_factor = yscale_factor * factor
case(SCALEZ)
   select case(key)
   case(GLUT_KEY_DOWN)
      factor = 1.0_gldouble/(1.0_gldouble + .02_gldouble)
   case(GLUT_KEY_UP)
      factor = 1.0_gldouble + .02_gldouble
   case default
      factor = 1.0_gldouble
   end select
   zscale_factor = zscale_factor * factor

end select
   
call glutPostRedisplay

return
end subroutine arrows

!          ------------
subroutine menu_handler(value)
!          ------------
integer(kind=glcint), intent(in out) :: value

! This routine handles the first level entries in the menu

select case(value)

case(RESET)
   call reset_to_init
case(QUIT)
   call glutLeaveMainLoop()

end select

return
end subroutine menu_handler

!          ---------------
subroutine set_left_button(value)
!          ---------------
integer(kind=glcint), intent(in out) :: value

! This routine sets the function of the left button as given by menu selection

left_button_func = value

return
end subroutine set_left_button

!          -----------------
subroutine set_middle_button(value)
!          -----------------
integer(kind=glcint), intent(in out) :: value

! This routine sets the function of the middle button as given by menu selection

middle_button_func = value

return
end subroutine set_middle_button

!          --------------
subroutine set_arrow_keys(value)
!          --------------
integer(kind=glcint), intent(in out) :: value

! This routine sets the function of the arrow keys as given by menu selection

arrow_key_func = value

return
end subroutine set_arrow_keys

!        ------------------
function view_modifier_init(scale) result(menuid)
!        ------------------

real(kind=gldouble), optional,intent(in) :: scale

integer(kind=glcint) :: menuid

! This initializes the view modifier variables and sets initial view.
! It should be called immediately after glutCreateWindow

integer(kind=glcint) :: button_left, button_middle, arrow_keys

if(present(scale)) then
init_xscale_factor=scale
init_yscale_factor=scale
init_zscale_factor=scale
endif

! set the callback functions

call glutMouseFunc(mouse)
call glutMotionFunc(motion)
call glutSpecialFunc(arrows)

! create the menu

button_left = glutCreateMenu(set_left_button)
call glutAddMenuEntry("rotate",ROTATE)
call glutAddMenuEntry("zoom",ZOOM)
call glutAddMenuEntry("pan",PAN)
call glutAddMenuEntry("scale x",SCALEX)
call glutAddMenuEntry("scale y",SCALEY)
call glutAddMenuEntry("scale z", SCALEZ)
button_middle = glutCreateMenu(set_middle_button)
call glutAddMenuEntry("rotate",ROTATE)
call glutAddMenuEntry("zoom",ZOOM)
call glutAddMenuEntry("pan",PAN)
call glutAddMenuEntry("scale x",SCALEX)
call glutAddMenuEntry("scale y",SCALEY)
call glutAddMenuEntry("scale z", SCALEZ)
arrow_keys = glutCreateMenu(set_arrow_keys)
 call glutAddMenuEntry("rotate",ROTATE)
 call glutAddMenuEntry("zoom",ZOOM)
 call glutAddMenuEntry("pan",PAN)
 call glutAddMenuEntry("scale x",SCALEX)
 call glutAddMenuEntry("scale y",SCALEY)
 call glutAddMenuEntry("scale z", SCALEZ)
 menuid = glutCreateMenu(menu_handler)
 call glutAddSubMenu("left mouse button",button_left)
 call glutAddSubMenu("middle mouse button",button_middle)
 call glutAddSubMenu("arrow keys",arrow_keys)
 call glutAddMenuEntry("reset to initial view",RESET)
 call glutAddMenuEntry("quit",QUIT)

! set the perspective

 call glMatrixMode(GL_PROJECTION)
 call gluPerspective(30.0_gldouble, 1.0_gldouble, 0.01_gldouble, 200.0_gldouble)

! set the initial view

 call glPushMatrix
 call reset_to_init

return
end function view_modifier_init

!        -----------
function sphere2cart(spoint) result(cpoint)
!        -----------
type(sphere3D), intent(in) :: spoint
type(cart3D) :: cpoint

! This converts a 3D point from spherical to cartesean coordinates

real(kind=gldouble) :: t,p,r

t=spoint%theta
p=spoint%phi
r=spoint%rho

cpoint%x = r*cos(t)*sin(p)
cpoint%y = r*sin(t)*sin(p)
cpoint%z = r*cos(p)

return
end function sphere2cart

!        -----------
function cart2sphere(cpoint) result(spoint)
!        -----------
type(cart3D), intent(in) :: cpoint
type(sphere3D) :: spoint

! This converts a 3D point from cartesean to spherical coordinates

real(kind=gldouble) :: x,y,z

x=cpoint%x
y=cpoint%y
z=cpoint%z

spoint%rho = sqrt(x*x+y*y+z*z)
if (x==0.0_gldouble .and. y==0.0_gldouble) then
   spoint%theta = 0.0_gldouble
else
   spoint%theta = atan2(y,x)
end if
if (spoint%rho == 0.0_gldouble) then
   spoint%phi = 0.0_gldouble
else
   spoint%phi = acos(z/spoint%rho)
endif

return
end function cart2sphere

!        ------------------
function cart3D_plus_cart3D(cart1,cart2) result(cart3)
!        ------------------
type(cart3D), intent(in) :: cart1, cart2
type(cart3D) :: cart3

! Compute the sum of two 3D cartesean points

cart3%x = cart1%x + cart2%x
cart3%y = cart1%y + cart2%y
cart3%z = cart1%z + cart2%z

return
end function cart3D_plus_cart3D

!        -------------------
function cart3D_minus_cart3D(cart1,cart2) result(cart3)
!        -------------------
type(cart3D), intent(in) :: cart1, cart2
type(cart3D) :: cart3

! Compute the difference of two 3D cartesean points

 cart3%x = cart1%x - cart2%x
 cart3%y = cart1%y - cart2%y
 cart3%z = cart1%z - cart2%z

return
end function cart3D_minus_cart3D

end module view_modifier

!********************************************************************

module nbody_viewer
use opengl_gl
use opengl_glu
use opengl_glut
use view_modifier

implicit none

integer, parameter :: NMAX=2000000 

real(kind=gldouble), parameter :: M_PI = 3.14159265358979323846_gldouble

type star
	real(kind=glfloat) x(0:1),y(0:1),z(0:1)
!	real(glfloat),dimension(3) :: &
!	color=(/1.0_glfloat,1.0_glfloat,1.0_glfloat,1.0_glfloat/)
end type star

integer(GLenum) doubleBuffer

logical,save :: show_gas=.TRUE., show_stars=.TRUE., show_halo=.TRUE., &
	 update_flag=.TRUE.,show_age=.FALSE.,show_temp=.FALSE.,     &
	 show_fuvheat=.FALSE.,show_div=.FALSE.,show_hsm=.FALSE.
	 
integer, save :: gas_color,star_color,halo_color	  

integer(glint), save ::framerate=100;

integer(glint), parameter:: FASTUPDATE=100,SLOWUPDATE=5000

real(kind=glfloat),save :: pointsize_gas=3,pointsize_stars=1.5,pointsize_halo=10.

real(kind=glfloat), dimension(3) :: pointpar=(/0.15,0.075,0.026/)

real(kind=gldouble), save :: initialbox
real(kind=gldouble) :: wwidth, wheight

 contains

recursive subroutine starreset(dummy)
	include 'globals.h'
	integer(glint),intent(inout) :: dummy
        real(kind=glfloat) :: xt,yt,zt,temp,red,green,blue,alpha_c
	integer :: i,step
	real(kind=glfloat) :: starscale=10.   ! scaling of brightness of stars with age
	real(kind=glfloat) :: lhmin,lhmax

 step=max(nbodies/NMAX,1)
 call gldeletelists(1,3)
	
 lhmin=log(minval(hsmooth(1:nsph))) 
 lhmax=log(maxval(hsmooth(1:nsph))) 
  
if(show_gas) then

	call glNewList(1,GL_COMPILE)	
	call glPointSize( pointsize_gas)
	if(show_fuvheat.OR.show_temp) then
	call glColor4f(.9_glfloat, .6_glfloat, .6_glfloat,.6_glfloat)
	else
	call glColor4f(1._glfloat, .8_glfloat, .8_glfloat,.6_glfloat)
	endif
	call glBegin(GL_POINTS)
	do i=1,nsph,step
	
	xt=pos(i,1)
	yt=pos(i,2)
	zt=pos(i,3)

	if(show_temp) then
	
	  temp=(alog10(csound(i)/.015))/2.
	  red=.4+.8*temp
	  blue=1.-2*temp*(1-temp)
	  green=.2+.6*temp**2
          alpha_c=.6
!	  alpha_c=.2+.5*temp
	  call glColor4f(red, green, blue,alpha_c)
	
	end if
	
	if(show_fuvheat) then
	
	  if(fuvheat(i).ge.0) then  
	  temp=log(fuvheat(i))-log(7.)
	  red=.2+temp/3
	  blue=1.+temp/3
	  green=.2+temp/3
	  alpha_c=.6	  
	  call glColor4f(red, green, blue,alpha_c)
	  endif
	end if

	if(show_div) then
	
	  red=0.
	  blue=0.
	  green=0.
	  if(hsmdivv(i).GT.0) then
          red=1.
          else
          blue=1.
          endif
          alpha_c=.6
	  call glColor4f(red, green, blue,alpha_c)
	
	end if

	if(show_hsm) then
	
	  green=(log(hsmooth(i))-lhmin)/(lhmax-lhmin)
	  blue=0.
	  red=1-green
    alpha_c=.7-.7*green
	  call glColor4f(red, green, blue,alpha_c)
	
	end if

	
	call glVertex3f(xt,yt,zt)
	
	
	end do
        call glEnd()
	call glEndList()

end if

if(show_stars) then

	call glNewList(2,GL_COMPILE)
	call glPointSize( pointsize_stars)
	call glColor4f(.8_glfloat, .8_glfloat, .6_glfloat,.6_glfloat)
	call glBegin(GL_POINTS)
	do i=nbodies-nstar+1,nbodies,step
	
	xt=pos(i,1)
	yt=pos(i,2)
	zt=pos(i,3)
	
	if(show_age) then
	
	 temp=exp((tform(i)-tnow)/starscale)
	
	red=.7+.3*temp;green=.6+.4*temp;blue=.3+.7*temp
		 
	call glColor4f(red, green, blue,.6_glfloat)
!	call glPointSize( (1._glfloat+3._glfloat*temp))
	end if
		
	call glVertex3f(xt,yt,zt)	
	end do
        call glEnd()
	call glEndList()

end if

! halo
if(show_halo) then

	call glNewList(3,GL_COMPILE)
	call glPointSize( pointsize_halo)
	call glColor4f(.25_glfloat, .25_glfloat, 1._glfloat,.9_glfloat)
	call glBegin(GL_POINTS)
	do i=nsph+1,nbodies-nstar,step
	
	xt=pos(i,1)
	yt=pos(i,2)
	zt=pos(i,3)
	
!	red=.75;blue=.75;green=.75
!	call glColor4f(red, green, blue,.8_glfloat)
		
	
	call glVertex3f(xt,yt,zt)
	
	end do
        call glEnd()
	call glEndList()

end if

 call glutPostRedisplay

 if(update_flag) call glutTimerFunc( framerate, starreset, 0)

end subroutine starreset

function starscale() result(scale_factor)

	include 'globals.h'
	real(kind=gldouble) :: maxcor,maxcorg,maxcors,scale_factor
! schaal:
	maxcor=maxval(abs(pos(1:nbodies,1:3)))	
	if(maxcor.le.0) maxcor=1.
        if(nsph.gt.0) then
	maxcorg=maxval(abs(pos(1:nsph,1:3)))	
	endif
	if(maxcorg.le.0) maxcorg=maxcor	
        if(nstar.gt.0) then
	maxcors=maxval(abs(pos(nbodies-nstar+1:nbodies,1:3)))	
	endif
	if(maxcors.le.0) maxcors=maxcor	
	maxcor=(maxcor*maxcorg*maxcors)**.33333
	scale_factor=2._gldouble/maxcor
	initialbox=2*maxcor
	return
end function starscale

subroutine outputtext(x,y,s)
  real(kind=gldouble) :: x,y
  character :: s*(*)
  character :: c
  integer :: i,lenc
  
  call glrasterpos2d(x,y)
  lenc = len(s)
  do i=1,lenc
    c = s(i:i)
    call glutbitmapcharacter(GLUT_BITMAP_HELVETICA_18, &
          ichar(c))
  end do
end subroutine outputtext

subroutine text
 include 'globals.h'
  character*8 rs
  call glmatrixmode(GL_PROJECTION)
  call glPushMatrix
  call glLoadIdentity
  call glortho(0._gldouble, wwidth, 0._gldouble, wheight,-1._gldouble,1._gldouble)
  call glmatrixmode(GL_MODELVIEW)
  call glPushMatrix
  call glLoadIdentity
  call glColor4f(0.0_glfloat,.5_glfloat,1.0_glfloat,0.5_glfloat)
  if(wheight.gt.120) then
  if(wwidth.gt.310) then
  write(rs,'(f8.2)') tnow*timescale/year/1.e6
  call outputtext(3._gldouble,3._gldouble,'time (Myr):'//rs)
  write(rs,'(f8.2)') initialbox*unitl_in_kpc
  call outputtext(wwidth-156._gldouble,3._gldouble,'box (kpc):'//rs)
  endif

  if(wwidth.gt.200) then
!  write(rs,'(I10)') nbodies-nstar-nsph
  call itos(nbodies-nsph-nstar,8,rs)
  call outputtext(3._gldouble,wheight-20._gldouble,'halo:')
  call outputtext(70._gldouble,wheight-20._gldouble,trim(rs))
  call itos(nsph,8,rs)
  call outputtext(3._gldouble,wheight-40._gldouble,'gas:')
  call outputtext(70._gldouble,wheight-40._gldouble,rs)
  call itos(nstar,8,rs)
  call outputtext(3._gldouble,wheight-60._gldouble,'stars:')
  call outputtext(70._gldouble,wheight-60._gldouble,rs)
  endif
  endif
  call glPopMatrix
  call glmatrixmode(GL_PROJECTION)
  call glPopMatrix
  call glmatrixmode(GL_MODELVIEW)
end subroutine text

subroutine reshape( w,h)
 integer(glint), intent(inout) :: w,h
 real(gldouble) ratio
 wwidth=w
 if(h.GT.1) ratio=w/(1.*h)
 wheight=MAX(h,1)
 call glViewPort(0,0,w,h)
 call glMatrixMode(GL_PROJECTION)
 call glLoadIdentity
 call gluPerspective(30.0_gldouble, ratio, 0.01_gldouble, 200.0_gldouble)

end subroutine reshape

subroutine display

 call reset_view
 call glClearColor(0.02_glfloat,0.02_glfloat,0.02_glfloat, 0.0_glfloat)
 call glClear(ior(GL_COLOR_BUFFER_BIT,GL_DEPTH_BUFFER_BIT))
 
 call glBlendFunc(GL_SRC_ALPHA, GL_ONE)
 call glDepthFunc(GL_ALWAYS)
 call glCallList(2)
 call glCallList(1)
 call glCallList(3)
 call glBlendFunc(GL_SRC_ALPHA, GL_ZERO)
 call glDepthFunc(GL_LESS)
 call glColor4f(.3_glfloat, .3_glfloat, .9_glfloat,.9_glfloat)
 call glutWireCube(initialbox)
 call glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA)
! call glDisable(GL_BLEND)
 call glDisable(GL_DEPTH_TEST)
 call text
! call glEnable(GL_BLEND)
 call glEnable(GL_DEPTH_TEST)
 call glutSwapBuffers

end subroutine display

subroutine axes

 call glNewList(3,GL_COMPILE)

! Draw axes so we know the orientation

 call glBegin(GL_LINES)
 call glVertex3f(0.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(2.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,2.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,0.0_glfloat)
 call glVertex3f(0.0_glfloat,0.0_glfloat,2.0_glfloat)

! Draw crude x, y and z to label the axes

 call glVertex3f(2.1_glfloat,-0.1_glfloat,0.1_glfloat) ! X
 call glVertex3f(2.1_glfloat,0.1_glfloat,-0.1_glfloat)
 call glVertex3f(2.1_glfloat,-0.1_glfloat,-0.1_glfloat)
 call glVertex3f(2.1_glfloat,0.1_glfloat,0.1_glfloat)
 call glVertex3f(0.1_glfloat,2.1_glfloat,0.1_glfloat) ! Y
 call glVertex3f(0.0_glfloat,2.1_glfloat,0.0_glfloat)
 call glVertex3f(-0.1_glfloat,2.1_glfloat,0.1_glfloat)
 call glVertex3f(0.1_glfloat,2.1_glfloat,-0.1_glfloat)
 call glVertex3f(-0.1_glfloat,0.1_glfloat,2.1_glfloat) ! Z
 call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
 call glVertex3f(0.1_glfloat,0.1_glfloat,2.1_glfloat)
 call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glVertex3f(-0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glVertex3f(0.1_glfloat,-0.1_glfloat,2.1_glfloat)
 call glEnd

 call glEndList

end subroutine axes

subroutine visible(state)
integer(glcint),intent(inout) :: state
  if (state == GLUT_VISIBLE) then
!   if(.not.update_flag) call glutTimerFunc( framerate, starreset,0)
   else
   update_flag=.FALSE. 
  endif
end subroutine visible


subroutine update_menu(optie)
integer(glcint),intent(inout) ::optie
logical ::flag
integer(glint) :: dummy

select case(optie)

case(1)
flag=update_flag
update_flag=.FALSE.
if(.NOT.update_flag) call starreset(dummy)
update_flag=flag
case(2)
framerate=SLOWUPDATE
if(.not.update_flag) then
  update_flag=.TRUE.
  call starreset(dummy)
end if
case(3)
framerate=FASTUPDATE
if(.not.update_flag) then
  update_flag=.TRUE.
  call starreset(dummy)
end if
case(4)
update_flag=.FALSE.
case default 

end select

end subroutine update_menu



subroutine show_menu(optie)
integer(glcint),intent(inout) :: optie
logical :: flag
integer(glint) :: dummy

select case (optie)
case(1)
show_stars=.NOT.show_stars
case(2)
show_gas=.NOT.show_gas
case(3)
show_halo=.NOT.show_halo
case(4)
 if(pointsize_gas.LT.10) then
 pointsize_gas=pointsize_gas*1.5
 pointsize_stars=pointsize_stars*1.5
 pointsize_halo=pointsize_halo*1.5
 endif
case(5)
 if(pointsize_gas.GT.1) then
 pointsize_gas=pointsize_gas/1.5
 pointsize_stars=pointsize_stars/1.5
 pointsize_halo=pointsize_halo/1.5
 endif
case default

end select

flag=update_flag
update_flag=.FALSE.
call starreset(dummy)
update_flag=flag

end subroutine show_menu

subroutine prop_menu(optie)
integer(glcint), intent(inout)::optie
logical :: flag
integer(glint) :: dummy

select case (optie)
case(1)
show_temp=.FALSE.
show_age=.FALSE.
show_fuvheat=.FALSE.
show_div=.FALSE.
show_hsm=.FALSE.
case(2)
show_temp=.NOT.show_temp
case(3)
show_age=.NOT.show_age
case(4)
show_fuvheat=.NOT.show_fuvheat
case(5)
show_div=.NOT.show_div
case(6)
show_hsm=.NOT.show_hsm
case default

end select

flag=update_flag
update_flag=.FALSE.
call starreset(dummy)
update_flag=flag

end subroutine prop_menu

end module nbody_viewer

subroutine viewbodies
 use nbody_viewer
 use view_modifier
 use opengl_gl
 use opengl_glut
 use opengl_glu

implicit none

integer(glcint) :: i,j,k,l
integer(glcint) :: win,menu
 
 if(glutGet(GLUT_ELAPSED_TIME).NE.0) then
!  print*,'already viewer present?'
!  return
 endif
 call glutInit
 call glutInitDisplayMode(ior(GLUT_DOUBLE,ior(GLUT_RGBA,GLUT_DEPTH)))
 call glutInitWindowPosition(100,100)
 call glutInitWindowSize(600,350)


win=glutCreateWindow("Stars3D Viewer")

i=glutCreateMenu(update_menu)
 call glutaddmenuentry('refresh view', 1)
 call glutaddmenuentry('slow update', 2)
 call glutaddmenuentry('fast update', 3)
 call glutaddmenuentry('no update', 4)

j=glutCreateMenu(show_menu)
 call glutaddmenuentry('toggle stars', 1)
 call glutaddmenuentry('toggle gas', 2)
 call glutaddmenuentry('toggle halo', 3)
 call glutaddmenuentry('increase pointsize', 4)
 call glutaddmenuentry('decrease pointsize', 5)

k=glutCreateMenu(prop_menu)
 call glutaddmenuentry('plain',1)
 call glutaddmenuentry('toggle temperature', 2)
 call glutaddmenuentry('toggle age', 3)
 call glutaddmenuentry('toggle fuvheat', 4)
 call glutaddmenuentry('toggle divv', 5)
 call glutaddmenuentry('toggle hsm', 6)

menu= view_modifier_init(starscale())

 call glutAttachMenu(GLUT_RIGHT_BUTTON)

 call glutaddsubmenu('update options', i)
 call glutaddsubmenu('view options', j)
 call glutaddsubmenu('show properties',k)

 call glutDisplayFunc(display)
 call glutReshapeFunc(reshape)

 call glClearColor(0.0_glclampf, 0.0_glclampf, 0.0_glclampf, 1.0_glclampf)

 call glEnable(GL_DEPTH_TEST)
 call glEnable(GL_BLEND)
 call glBlendFunc(GL_SRC_ALPHA, GL_ONE)
 call glEnable(GL_LINE_SMOOTH)
 call glEnable(GL_POINT_SMOOTH)
 call glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
 call glHint(GL_POINT_SMOOTH_HINT, GL_FASTEST)
! CALL glPointParameterfvEXT(GL_DISTANCE_ATTENUATION_EXT,pointpar)
! call glPointParameterfEXT(GL_POINT_SIZE_MIN_EXT, 1._glfloat) 
! call glPointParameterfEXT(GL_POINT_FADE_THRESHOLD_SIZE_EX, 0._glfloat) 

 call glutTimerFunc(100, starreset,0)
 call glutVisibilityFunc(visible)

 call glutSetOption(GLUT_ACTION_ON_WINDOW_CLOSE,GLUT_ACTION_GLUTMAINLOOP_RETURNS)
 call glutMainLoop()

end subroutine viewbodies


subroutine pt_setup
	
end subroutine pt_setup

module MoleculeMod
  implicit none
 private
 public :: InitMolecule, h2fraction,polyQ 

 real, parameter :: xifuv=3             ! 2-4
 real, parameter :: mu=17.5              ! formation rate const. mu, min: 3.5
 integer, parameter :: poly=1           ! polytropic index
 real, parameter :: nzero=1500          ! cm^-3
 real, parameter :: pzero=1.e4          ! K cm^-3
 real, parameter :: pcut=1000.		! K cm^-3 (transition pressure) 
 real, parameter :: k0=4.e-11		! dissociation rate s^-1
 real, parameter :: kboltz=1.38e-23     ! SI
 real, parameter :: amu=1.67e-27        ! SI
 real, parameter :: sqrtpi=1.772453851
 real, parameter :: year=3.15576e7
 real, parameter :: sigmav=4.9e-22	! cm^2
 real, parameter :: pc=3.086e18		! cm

 real, parameter :: Tform=1000,Tdes=3000,T4=10000	! temperature intervals 

 real, save :: metal,meanmwt,meann,fmin,n0con

 logical, parameter :: debug=.FALSE.

 contains

subroutine InitMolecule(metallicity)
  use ElementsMod
 character(len=*), optional :: metallicity

 
 print*,' using molecule formation routines!'
 print*,'  > formation rate constant:', mu
 if(poly.EQ.0) print*,'  > constant density clouds'
 if(poly.EQ.1) print*,'  > logotropic clouds' 
     
 if(present(metallicity)) then
  call InitElements(metallicity)
 else
  call InitElements()
 endif

 metal=zQ()/solarzQ()
 meanmwt=meanmwtQ() 
 meann=1./fractionQ(elementnrQ("H   "))
 n0con=xifuv*sigmav*pc
 
 if(poly.NE.0.AND.poly.NE.1) call molError(1)
 
 if(poly.eq.0) fmin=0.
 if(poly.eq.1) fmin=1.e-6
 
end subroutine 


! dt in year, n in cm^-3, T in K , g0 in units of Draine field, disp in km/s
subroutine h2fraction(fh2,dt,n,T,g0,disp,z,xe)
  real,intent(inout) :: fh2
  real,intent(in) :: n,T,g0,dt,disp
  real,intent(in), optional :: z,xe
  real ptot,lz,afuv,amean,ficonstant,dtau,snzero,ipar,Rf,acr,lxe
  integer :: i,j
 
 if(.not.present(z)) then
  lz=metal
 else
  lz=z
 endif
 
 if(.not.present(xe)) then
  lxe=0.0
 else
  lxe=xe
 endif  
 
 if(debug) print*,'*1*',fh2,dt,n,T,g0,disp,lz
 
 fh2=max(fmin,fh2)

 if(dt.LE.0) return

 if(n.GT.1.e10.AND.T.LE.Tform) then
  fh2=1.
  return
 endif    
 if(T.GT.T4) then
  fh2=fmin
  return
 endif 
 if(T.GT.Tdes) then 
  dtau=dt/taudiss(T,n,lxe)
  call fh2des(dtau,fh2) 
 endif
 if(debug) print*,'*2*',fh2,dtau
! ficonstant=6.6e-6*sqrtpi*(lz*xifuv)**.5
 ficonstant=3.39e-6*sqrtpi*(lz*xifuv)**.5
 ptot=(meann+lxe)*n*T+1.e6*meanmwt*meann*n*disp**2*amu/kboltz/3.
 amean=meanAv(ptot,lz)
 afuv=xifuv*atrans(fh2,amean)
 if(debug) print*,'*3*', ficonstant,ptot,amean,afuv
 if(T.GT.Tform) then
  dtau=2*g0*k0*ficonstant*dt*year
!  afuv=log(exp(afuv)+dtau) 
  afuv=afuv+log(1+dtau*exp(-afuv))
 endif
 if(debug) print*,'*4*', dtau,afuv
 if(T.LE.Tform) then
  Rf=rform(T,lz)
  dtau=2*n*Rf*dt*year
  ipar=g0*k0*ficonstant/n/Rf
  if(debug) print*,'*5*',Rf,dtau,ipar
  if(poly.EQ.0) then
   call solveh2_explicit(ipar,dtau,afuv)   
!   j=INT(10*dtau)+1
!   do i=1,j
!    call solveh2(ipar,dtau/j,afuv)
!   enddo 
   if(debug) print*,'*6*',j,afuv
  endif
  if(poly.EQ.1) then
   dtau=dtau*2./3.
   snzero=2./3.*nzero*n0con*(ptot/pzero)**.5
   call solveh2log_explicit(ipar,dtau,snzero,afuv)   
!   j=INT(10*dtau)+1
!   do i=1,j
!    call solveh2log(ipar,dtau/j,snzero,afuv)
!   enddo 
   if(debug) print*,'*6*',j,afuv,snzero
  endif
 endif
 acr=afuv/xifuv
 fh2=fmol(acr,amean)
 fh2=max(fmin,fh2)
end subroutine


subroutine molError(i)
  integer i
 
 if(i.eq.1) print*,' poly not equal to 0 or 1'
 
 stop
  
end subroutine


function rform(T,z) ! formation rate in cm^3 s^-1
 real :: rform,z,T
 real, parameter :: Tref=102
 rform=3.5e-18*z*T**.5/(1+T/Tref)**2*mu
 if(T.gt.Tform) rform=0
end function 

function fmol(acr,av) 
  real :: fmol,acr,av
 if(poly.EQ.0) then
  if(acr.gt.3./4.*av) then 
   fmol=0
  else
   fmol=(1.-4./3.*acr/av)**3
  endif
 endif
 if(poly.EQ.1) then
  fmol=exp(-4.*acr/av)
 endif
end function

function atrans(fm,av)
  real :: fm, atrans,av
 if(poly.eq.0) then
  atrans=3./4.*av*(1-fm**(1./3.))
 endif
 if(poly.eq.1) then
  atrans=-av/4.*log(fm)
 endif
end function

function meanAv(pe,z)
  real :: pe,z,meanAv
 if(pe.gt.pcut) then
  meanAv=.22*z*(nzero/100)*sqrt(pe/pzero)
 else
  meanAv=.22*z*(nzero/100)*pe/pzero*sqrt(pzero/pcut)
 endif 
end function

subroutine solveh2(alphaG,dbeta,sn)
 real, intent(in) :: alphaG, dbeta
 real, intent(inout) :: sn
 real, parameter :: precision=0.0001
 real :: fi,dfi,sn1, sn2,esn
 integer :: i
 integer,parameter :: imax=100
  
 i=0 
 sn2=sn 
10 continue
 i=i+1
 sn1=sn2
 esn=exp(-sn1)
 fi=sn1-sn-dbeta*(alphaG*esn-sn1)
 dfi=1+dbeta*(alphaG*esn+1)
 sn2=sn1-fi/dfi 
 if(i.gt.imax) return
 if(ABS(sn2-sn1).GT.precision*sn1) goto 10
 sn=sn2
end subroutine

subroutine solveh2log(alphaG,dbeta,snzero,sn)
 real, intent(in) :: alphaG, dbeta,snzero
 real, intent(inout) :: sn
 real, parameter :: precision=0.0001
 real :: fi,dfi,sn1, sn2,esn,esn1
 integer :: i
 integer,parameter :: imax=100
  
 i=0 
 if(sn.gt.50*snzero) sn=50*snzero
 sn2=sn     
10 continue
 i=i+1
 if(sn2.gt.50*snzero) sn2=50*snzero
 sn1=sn2
 esn=exp(-sn1)
 esn1=exp(sn1/snzero)
 fi=sn1-sn-dbeta*(alphaG*esn-snzero*(esn1-1))
 dfi=1+dbeta*(alphaG*esn+esn1)
 sn2=sn1-fi/dfi 
 if(i.gt.imax) return
 if(ABS(sn2-sn1).GT.precision*sn1) goto 10
 sn=sn2
end subroutine

subroutine solveh2log_explicit(alphaG,dbeta,snzero,sn)
 real, intent(in) :: alphaG, dbeta,snzero
 real, intent(inout) :: sn
 real, parameter :: fac=0.001
 real :: fi,dfi,sn1, sn2,esn,esn1,dtau,tau

 sn1=sn
 tau=0
 do while(tau.LT.dbeta)
   esn=exp(-sn1)
   esn1=exp(sn1/snzero)
   dfi=(alphaG*esn-snzero*(esn1-1))
   dtau=abs(fac*sn1/dfi)
   if(sn1.EQ.0) dtau=abs(1.e-8/dfi)
   if((dbeta-tau).LT.dtau) then
     dtau=dbeta-tau
     tau=dbeta
   else
     tau=tau+dtau
   endif
   if(dfi.EQ.0) then 
     exit
   endif
   sn1=sn1+dtau*dfi
 enddo
 sn=sn1
end subroutine

subroutine solveh2_explicit(alphaG,dbeta,sn)
 real, intent(in) :: alphaG, dbeta
 real, intent(inout) :: sn
 real, parameter :: fac=0.001
 real :: fi,dfi,sn1, sn2,esn,esn1,dtau,tau

 sn1=sn
 tau=0
 do while(tau.LT.dbeta)
   esn=exp(-sn1)
   dfi=(alphaG*esn-sn1)
   dtau=abs(fac*sn1/dfi)
   if(sn1.EQ.0) dtau=abs(1.e-8/dfi)
   if((dbeta-tau).LT.dtau) then
     dtau=dbeta-tau
     tau=dbeta
   else
     tau=tau+dtau
   endif
   if(dfi.EQ.0) then 
     exit
   endif  
   sn1=sn1+dtau*dfi
 enddo
 sn=sn1
end subroutine

subroutine fh2des(beta,fh2) ! collissional h2 destruction (gamma2=gamma1/20)
 real :: beta,fh2
 fh2=20*fh2*exp(-beta)/(19*fh2*exp(-beta)+(20-19*fh2))
end subroutine

 function taudiss(T,n,xe) result(tau)
  real :: tau
  real, intent(in) :: T,n,xe
  real :: tau1,tau2,lxe
  
  lxe=MIN(1.,xe)

  tau1=taudiss1(T,n)
  tau2=taudiss2(T,n)
  tau=1./((1-lxe)/tau1+lxe/tau2)
!  print*,tau,tau1,tau2
 end function 

 function taudiss1(T,n) result(tau)
  real :: tau
  real, intent(in) :: T,n
  real, parameter :: Tref=3162,tauref=3.2e10,Tmin=3000,Tmax=10000
!  if(T.LT.Tmin) then
!   tau=tauref*(Tref/Tmin)**12/n 
!   return
!  endif
  if(T.GT.Tmax) then
   tau=tauref*(Tref/Tmax)**12/n
   return
  endif  
  tau=tauref*(Tref/T)**12/n
 end function

 function taudiss2(T,n) result(tau)
  real :: tau
  real, intent(in) :: T,n
  real, parameter :: Tref=3162,tauref=3.2e7,Tmin=3000,Tmax=10000
!  if(T.LT.Tmin) then
!   tau=tauref*(Tref/Tmin)**12/n 
!   return
!  endif
  if(T.GT.Tmax) then
   tau=tauref*(Tref/Tmax)**6/n
   return
  endif  
  tau=tauref*(Tref/T)**6/n
 end function

 function polyQ()
  integer polyQ
  polyQ=poly
 end function 

end module

subroutine h2test
 use MoleculeMod
 real :: fh2,dt,n,T,g0,disp,p
 real :: tform,feq,tdiss,tdes,xe
 integer :: i,j,k,l
 
 print*,'molecule formation routine test'

 call InitMolecule

print*,' fh2,dt,n,T,disp,g0,xe'
10 read*,fh2,dt,n,T,disp,g0,xe
 if(n.eq.0) stop 
  call h2fraction(fh2,dt,n,T,g0,disp,xe=xe)
 print*,dt,fh2
 goto 10
end 

program fi
  include 'globals.h'
  integer omp_get_max_threads
  real time,rtime
  integer n1,n,ioerror

  print*,' --- FI ---'  
  call initmem(nbodsmax,nsphmax,ncells)
!$  print*,' omp threads:',omp_get_max_threads()    
  time=rtime()
  print*,' '
  print*,' compiled with:'
  if(periodic) then
    print*,' > periodic boundary'
  else
    print*,' > vacuum boundary'
  endif
  if(sortpart) then
    print*,' > particle sorting'
  else
    print*,' > no particle sorting'
  endif
  if(H2cooling) then
    print*,' > h2 cooling'
  else
    print*,' > no h2 cooling'
  endif
  if(ionCool) then
    print*,' > variable ionization'
  else
    print*,' > fixed ionization'
  endif
  if(simpleeff) then
    print*,' > simple heating efficiency'
  else
    print*,' > full heating efficiency'
  endif
  if(cosmrayheat) then
    print*,' > cosmic ray heating'
  else
    print*,' > no cosmic ray heating'
  endif
  if(usepm) then
    print*,' > pm gravity'
  else
    print*,' > no pm gravity'
  endif
  print*,' > compiled constraints:'
  print*,'    no. of particles: ',nbodsmax
  print*,'    no. of sph part:  ',nsphmax
  print*,'    no. of cells:     ',ncells
  print*,' '
  open(unit=uboddump,file=dumpfile,status='OLD',iostat=ioerror)
  close(uboddump)
  if(ioerror.NE.0) then 
    call initsys
    n1=0
    print *,' ...starting simulation...'
  else
    call initdump(n1)
    print *,' ...restarting simulation...'
  endif 
  if(verbosity.GT.0) then
    print*,'  > verbosity level:', verbosity
  endif
  call maphimap(n1)
  do n=n1+1,nsteps
    call stepsystem(n)
    call maphimap(n)
  enddo
  print*, ' finished run'
end program

module mapinterface
  use map_helpers
  
contains

function initialize_code() result(ret)
  integer :: ret
  ret=0
end function

function generate_projection() result(ret)
  integer :: ret
  call map_generate_projection()
  ret=0
end function

function init_map() result(ret)
  integer :: ret
  ret=map_init()
end function

function reset_map() result(ret)
  integer :: ret
  call map_reset()
  ret=0
end function

function erase_map() result(ret)
  integer :: ret
  call map_erase()
  ret=0
end function    

function cleanup_code() result(ret)
  integer :: ret
  call map_reset()
  ret=0
end function

function new_particle(id,x,y,z,m,r,o,i) result(ret)
  integer :: ret,i,id
  real :: m,x,y,z,r,o
  ret=add_particle(id,m,x,y,z,r,o,i)
end function

function set_state(id,x,y,z,m,r,o) result(ret)
  integer :: ret,id
  real :: m,x,y,z,r,o
  ret=set_particle_state(id,m,x,y,z,r,o)
end function

function set_weight(id,m) result(ret)
  integer :: ret,id
  real :: m
  ret=set_particle_weight(id,m)
end function

function set_opacity_area(id,m) result(ret)
  integer :: ret,id
  real :: m
  ret=set_particle_opacity_area(id,m)
end function

function get_state(id,x,y,z,m,r,o) result(ret)
  integer :: ret,id
  real :: m,x,y,z,r,o
  ret=get_particle_state(id,m,x,y,z,r,o)
end function


function delete_particle(id) result(ret)
  integer ret,id
  ret=map_remove_particle(id)
end function  

function set_random_seed(x) result(ret)
  integer :: x
  integer :: ret
  ret=map_set_random_seed(x)
end function
function get_random_seed(x) result(ret)
  integer :: x
  integer :: ret
  ret=map_get_random_seed(x)
end function

function set_minimum_distance(x) result(ret)
  real :: x
  integer :: ret
  call map_set_zm(x)
  ret=0
end function
function get_minimum_distance(x) result(ret)
  real :: x
  integer :: ret
  call map_get_zm(x)
  ret=0
end function

function set_extinction_flag(x) result(ret)
  integer :: x
  integer :: ret
  call map_set_ext(x)
  ret=0
end function
function get_extinction_flag(x) result(ret)
  integer :: x
  integer :: ret
  call map_get_ext(x)
  ret=0
end function

function set_image_angle(x) result(ret)
  real :: x
  integer :: ret
  call map_set_angle(x)
  ret=0
end function
function get_image_angle(x) result(ret)
  real :: x
  integer :: ret
  call map_get_angle(x)
  ret=0
end function

function set_image_width(x) result(ret)
  real :: x
  integer :: ret
  call map_set_width(x)
  ret=0
end function
function get_image_width(x) result(ret)
  real :: x
  integer :: ret
  call map_get_width(x)
  ret=0
end function

function set_image_pixel_size(nx,ny) result(ret)
  integer :: nx,ny
  integer :: ret
  call map_set_imsize(nx,ny)
  ret=0
end function
function get_image_pixel_size(nx,ny) result(ret)
  integer :: nx,ny
  integer :: ret
  call map_get_imsize(nx,ny)
  ret=0
end function

function set_image_target(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_set_focus(x,y,z)
  ret=0
end function
function get_image_target(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_get_focus(x,y,z)
  ret=0
end function

function set_viewpoint(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_set_viewpoint(x,y,z)
  ret=0
end function
function get_viewpoint(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_get_viewpoint(x,y,z)
  ret=0
end function

function set_upvector(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_set_upvector(x,y,z)
  ret=0
end function
function get_upvector(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_get_upvector(x,y,z)
  ret=0
end function

function set_projection_direction(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_set_direction(x,y,z)
  ret=0
end function
function get_projection_direction(x,y,z) result(ret)
  real :: x,y,z
  integer :: ret
  call map_get_direction(x,y,z)
  ret=0
end function

function set_projection_mode(x) result(ret)
  integer :: ret
  character(len=15), intent(in) :: x
  if(x.NE."parallel".AND.x.NE."perspective") then
    ret=-1
    return
  endif
  call map_set_projection_mode(x)
  ret=0
end function
function get_projection_mode(x) result(ret)
  integer :: ret
  character(len=15), intent(out) :: x
  call map_get_projection_mode(x)
  ret=0
end function



function get_image(i,j,pic,n) result(ret)
  integer n,ret,i(n),j(n)
  real :: pic(n)
  ret=map_get_pic(i,j,pic,n)
end function  

function get_opdepth_map(i,j,pic,n) result(ret)
  integer n,ret,i(n),j(n)
  real :: pic(n)
  ret=map_get_opdepth(i,j,pic,n)
end function

end module

subroutine heattabel
  use ElementsMod
  use CoolingMod
  use IonMod
  use MoleculeMod
  use H2CoolMod
  use starsMod
  include "globals.h"
  integer hy

  if(verbosity.GT.0) print*,' ...InitElements...'
  call InitElements(metallicity)
  if(verbosity.GT.0) print*,'  > compiled metallicity:', zQ()/solarzQ()
  if(nstar.GT.0) then
    if(verbosity.GT.0)print*,' ...InitStars...'
    call InitStars(datadir,zQ())
  endif
  if(radiate) then
    if(verbosity.GT.0) print*,' ...InitCooling...'
    call InitCooling(datadir)
    call InitH2(datadir)
    if(verbosity.GT.0) print*,' ...InitIon...'
    call InitIon(unitm_in_msun,unitl_in_kpc)
    if(verbosity.GT.0) print*,' ...InitMolecules...'
    call InitMolecule
  endif

! solarz scaling with elements present 	
  hy=elementnrQ("H   ")
!  meanmwt=meanmwtQ()/fractionQ(hy)
  meanmwt=meanmwtQ()
  fhydrogn=wfractionQ(hy)
end subroutine

function heateff( t, fuv, ne)
  real fuv,t,ne,heateff,fuvtne
!  wolfire 1995 formula (2) / 0.05 (<- reference value for graineff)
  fuvtne=fuv*t**.5/ne
  heateff= 0.98 /(1+(fuvtne/1925)**.73) &
                  + 0.74*(t/1.e4)**.7/(1+(fuvtne/5000.))
  heateff=heateff*exp(-(t/2.e4)**2)
end function

function heateff2( t, fuv, ne)
  real fuv,t,ne,heateff2,fuvtne
! common sense grain heating efficiency? 
  heateff2=exp(-(t/2.e4)**2)
end function

function ffcooling(temp,p)
  include 'globals.h'
  integer p
  real ffcooling,temp
  real gff,ffconst,xe
  parameter(gff=1.3,ffconst=1.42e-6)
  ffcooling=0
  if(temp.lt.1e5) return 
  ffcooling=gff*ffconst*cool_par*temp**.5*rho(p)*fhydrogn**2
end function

subroutine heco(heating,cooling,eth,p)
  use CoolingMod
  use IonMod
  use HeatingMod
  use H2coolMod
  include 'globals.h'
  real cooling,heating,eth,nh
  real ttemp,temp,xelec,grainc,h2f,xh
  real heateff,heateff2
  integer p
	 
  nh=densconst*rho(p)
  h2f=h2frac(p)
  ttemp=eth*mumhkg1
  if(ionCool) then
    call Ion(ttemp,temp,xelec,nh,crionrate)
!    call Ionh(ttemp,temp,xelec,xhii,xheii,xheiii,nh,crionrate)
  else
    temp=ttemp
    xelec=0.1
  endif
	 
  if(simpleeff) then
    grainc=graineff*heateff2(temp,fuvheat(p)/heatconst,xelec*nh)
  else 
    grainc=graineff*heateff(temp,fuvheat(p)/heatconst,xelec*nh)
  endif
	 
  heating=fhydrogn*(fuvheat(p)*grainc+esnthdt(p)+ &
            grainc/graineff*heat_par1) + heat_par2*rho(p)*fhydrogn**2

  if(cosmrayheat) heating=heating+ &
                    fhydrogn*crionrate*1.6e-5*heatconst*crheat(xelec)

! constant (cosmological) heating term
!  heating=heating+fhydrogn*heat_par1*(1-xh)
         
!  cooling=cool_par*H2CoolFunc(xelec,temp,h2f)*rho(p)

  if(.NOT.H2Cooling) then
    cooling=cool_par*CoolFunc(xelec,temp)*rho(p)
  else
    cooling=cool_par*rho(p)*(CoolFunc(xelec,temp)+h2f*H2CoolFunc(temp,nh))
  endif

end subroutine
	 	 	
subroutine temperature
  use IonMod
  include 'globals.h'
  real ttemp,temp,xe,n
  integer p
	 
  if(isotherm) return 
!$omp parallel do private(ttemp,temp,xe,n)
  do p=1,nsph
    if(rho(p).EQ.0) cycle
!    if(uentropy) then
!      ttemp=mumhkg1*ethermal(p)/gamma1*rho(p)**gamma1
!    else
!      ttemp=mumhkg1*ethermal(p)
!    endif
    n=rho(p)*densconst
    ttemp=mumhkg1*csound(p)**2/gamma/gamma1	 
    if(radiate) then
      call Ion(ttemp,temp,xe,n,crionrate)
    else
      temp=ttemp
      xe=0.00001
    endif  
    temperat(p)=temp
    elecfrac(p)=xe
  enddo

end subroutine

subroutine molecules
  use MoleculeMod
  include 'globals.h' 
  real fh2,dt,n,T,g0,disp,lxe
  integer p

  dt=(tnow-h2time)*timescale/year
!$omp parallel do private(p,fh2,n,T,g0,disp,lxe) shared(dt)	
  do p=1,nsph
    if(rho(p).EQ.0) cycle
    fh2=h2frac(p)
    n=rho(p)*densconst
    T=temperat(p)
! 2pi/ 4pi and Habing -> Draine
    g0=fuvheat(p)/heatconst/2./1.71 
    disp=vdisp(p)*velscale/1.e5
    lxe=elecfrac(p)
    call h2fraction(fh2,dt,n,T,g0,disp,xe=lxe)	
    h2frac(p)=fh2  
  enddo

  h2time=tnow
end subroutine
        

subroutine outhead
  include 'globals.h'
  character(len=4) type
  character(len=8) halocore,halodens
  character(len=10) halotype
  integer id,ierr
        
  open(UNIT=ulog,FILE=logfile,STATUS='OLD',position='APPEND',IOSTAT=ierr)
  if(ierr.NE.0) then
    if(verbosity.GT.0) print*,' logfile not found'
    return
  endif 

  write(ulog,'("initial nbodies, nsteps: ",4i9)') nbodies,nsteps
  write(ulog,'("output-interval bodies, energy: ",4i9)') stepout,steplog
  write(ulog,*) 'see parameter file'
  write(ulog,*)
  close(ulog)

end subroutine

subroutine startout
  include 'globals.h'
  integer ioerror
  character(len=4) sstring
  
  open(unit=upars,file='stop',status='UNKNOWN')
  read(upars,'(a)',iostat=ioerror) sstring 
  if(ioerror.EQ.0.AND.sstring.EQ.'stop') then
    print*,'stop -- stop file already present'
    print*,'     -- please remove or alter ' 
    stop
  endif 
  close(upars)

  print*,' ...making log...'
  open(UNIT=ulog,FILE=logfile,STATUS='NEW',IOSTAT=ioerror)
  if(ioerror.NE.0) then
    print*,'stop -- cannot make new log file: ',logfile
    stop
  endif
  write(ulog,*) ' Start of logfile output '
  close(ulog)
 
  open(unit=sfrfilenr,file=TRIM(outputfile)//'.sfh',status='unknown')
  write(sfrfilenr,*) ' star formation history '
  close(sfrfilenr)

  open(unit=erasenr,file=TRIM(outputfile)//'.del',status='unknown')
  write(erasenr,*) ' erased mass '
  write(erasenr,*) ' time, mass, com pos, com vel'
  close(erasenr)

  open(unit=bhfilenr,file=TRIM(outputfile)//'.bh',status='unknown')
  write(bhfilenr,*) ' blackhole accretion history'
  write(bhfilenr,'(a)',advance='NO') & 
    '1 origindex,2 time,3 reff,4 rho,5 csound,6 vbulk,7 drhodt,' 
  write(bhfilenr,'(a)',advance='NO') &
    '8 temp,9 mdot_bondi,10 mdot_divv,11 mdot_edd,12 mdot,'
  write(bhfilenr,'(a)') &
    '13 bhmass,14 h,15 x,16 y,17 z,18 drhodh,19 vx,20 vy,21 vz'
  close(bhfilenr)

end subroutine

subroutine outenrgy
  include 'globals.h'
  integer :: k,ioerr
  real :: cpunew,cpustep,etotrad,rtime
  real, save :: cpuold=0.0

  open(UNIT=ulog,FILE=logfile,STATUS='OLD',position='APPEND',IOSTAT=ioerr)
  if(ioerr.NE.0) then
    if(verbosity.GT.0) print*,' no log file'
    return
  endif  
  
  etotrad=etot-eradiate-snheat-enerror

  if(.NOT.starform) then
    write(ulog,'("mtot,mgas = ",2(1pe17.9))') mtot,mgas
  else
    write(ulog,'("mtot,mgas,mstar = ",3(1pe17.9))') mtot,mgas,mstar
    write(ulog,'("cold,luke,warm,hot = ",4(1pe17.9))') mcold,mluke,mwarm,mhot
  endif
  write(ulog,'("e, e_kin, e_pot = ",3(1pe17.9))') etotrad,ektot,eptot
  write(ulog,'("e_th, e_soft = ",2(1pe17.9))') ethtot,esofttot

  if(radiate) then
    write(ulog,'("e_radiated = ",1(1pe17.9))') eradiate
    write(ulog,'("e_fuv, e_cool, e_star = ",3(1pe17.9))') &
      efuvheat,eradcool,estar
  endif

  if(starform) then
    write(ulog,'("e_snheat = ",1(1pe17.9))')  snheat
  endif

  write(ulog,'("am_x, am_y, am_z = ",3(1pe17.9))') amvec(1),amvec(2),amvec(3)
  write(ulog,'("x_cm, y_cm, z_cm = ",3(1pe17.9))') cmpos(1),cmpos(2),cmpos(3)
  write(ulog,'("vx_cm, vy_cm, vz_cm = ",3(1pe17.9))') cmvel(1),cmvel(2),cmvel(3)

  cpunew=rtime()
  cpustep=cpunew-cpuold
  cpuold=cpunew
  write(ulog,'("wall clock time = ",1(1pe17.9))') cpustep
  write(ulog,*)
  close(ulog)

end subroutine

subroutine outlog(istep)
  include 'globals.h'
  integer :: istep,i,ibin,tstepbin(20),p,ioerr
  real :: tistep

  if(istep.EQ.0) call outhead
  open(UNIT=ulog,FILE=logfile,STATUS='OLD',position='APPEND',IOSTAT=ioerr)
  if(ioerr.NE.0) then
    if(verbosity.GT.0) print*,' no log file'
    return
  endif
	 
  if(cosmo) then
    write(ulog,'("time, a, Z, ncells = ",3(1pe17.9), i9)') tnow,1.0,0.,incellsg
  else
    write(ulog,'("time, ncells = ",(1pe17.9),i9)') tnow,incellsg
  endif
  write(ulog,'("nttot,ntmin,ntmax,ntavg = ",4i12)') nttot,ntmin,ntmax,ntavg
  write(ulog,'("nntot,ntmin,ntmax,ntavg = ",4i12)') nntot,nnmin,nnmax,nnavg
  if(adaptive_eps) &
    write(ulog,'("nstot,ntmin,ntmax,ntavg = ",4i12)') nstot,nsmin,nsmax,nsavg
  if(usesph) then
    tstepbin(1:20)=0
    do p=1,nsph
      tstepbin(itimestp(p))=tstepbin(itimestp(p))+1
    enddo
    write(ulog,'("timestep distribution SPH = ",20i9)') tstepbin(1:20)
  endif
  tstepbin(1:20)=0
  do p=nsph+1,nbodies
      tstepbin(itimestp(p))=tstepbin(itimestp(p))+1
  enddo
  write(ulog,'("timestep distribution non-SPH = ",20i9)') tstepbin(1:20)
  write(ulog,*)
  close(ulog)

end subroutine

subroutine fuvflux
  include 'globals.h'
  integer p,i,j,nterms,nedge,nnonedge,totalsearches
  real :: time1,time2,mintime,maxtime,tottime,utime1,utime2
  integer, parameter :: nbuf=32
  integer :: omp_get_max_threads
  integer :: maxthread, nchunk,k,imin,imax,ib, buf(nbuf),todo(nbuf),ntodo
  integer :: niter
  
  if(nstar.LE.0.OR.nsphact.LE.0) return
  if(.NOT.directsum.AND.nstar.GT.ntreemin) call startree

  nttotfuv=0; ntminfuv=nbodies; ntmaxfuv=0
  mintime=1.e10; maxtime=0.; tottime=0
  totalsearches=0

  maxthread=1
  nchunk=1
  niter=0
!$  maxthread=omp_get_max_threads()
!$  nchunk=MAX(MIN(10*maxthread,nsphact/nbuf),maxthread)	

!$omp parallel &
!$omp shared(root,nchunk) & 
!$omp private(p,nterms,time1,time2, &
!$omp imin,imax,ib,i,k,buf,todo,ntodo) &
!$omp reduction( + : nttotfuv,tottime,totalsearches,niter) & 
!$omp reduction( MIN : ntminfuv, mintime) &
!$omp reduction( MAX : ntmaxfuv, maxtime)
  call wall_time(time1)
  ncalls=0;nsearches=0		
!$omp do schedule(guided,1)
  do k=1,nchunk
    buf=0
    imin=int(nsphact*float(k-1)/nchunk)+1
    imax=int(nsphact*float(k)/nchunk)
    reuseflag=1; searchreuse=0
    do i=imin,imax
      call prefuvwalk(i,imax,nbuf,buf,ntodo,todo)	   
      do ib=1,ntodo
        niter=niter+1
        p=todo(ib)
        if(.NOT.directsum.AND.nstar.GT.ntreemin) then
          call pcond_fuvwalk(root,p,nterms)
        else
          nterms=nstar
          do j=1,nstar
            bodlist(j)=j+nbodies-nstar
          enddo
        endif

        if(.not.periodic) then
          call pfuvsum(p,nterms)
        else
! check that periodic treewalk gives only nearest image
          call terror('periodic broken at the moment..')
        endif                 
        nttotfuv=nttotfuv+nterms
        ntminfuv=MIN(ntminfuv,nterms)
        ntmaxfuv=MAX(ntmaxfuv,nterms)
      enddo
    enddo  
  enddo	  
!$omp enddo nowait 
  call wall_time(time2)
  mintime=MIN(mintime,time2-time1)
  maxtime=MAX(maxtime,time2-time1)
  tottime=tottime+time2-time1
  totalsearches=totalsearches+nsearches
!$omp end parallel
  ntavgfuv=nttotfuv/nsphact
  if(verbosity.GT.0) then
    print*,'<fuvflux> parts,searches:', nsphact,totalsearches
    write(*,'(" <fuvflux> time:", 3f8.2)') maxtime,mintime,tottime
    print*,'<fuvflux> mn,av,mx:',ntminfuv,ntavgfuv,ntmaxfuv
  endif
  if(niter.NE.nsphact) call terror("fuvflux inconsistent iter count")
end subroutine
				
subroutine zerofuv
  include 'globals.h'  
  fuvheat(pactive(1:nsphact))=0.
end subroutine

program combsimple
 integer :: i,nbod1,nbod2,nsph1,nsph2,nstar1,nstar2,ioer
 real :: pmass,x(3),v(3)
 character*200 :: filename1,filename2,outfile
 
print*,'** combine to <simple> snapshot files **'
print*,'file 1?'
read*, filename1
print*,'file 2?'
read*,filename2
print*,'output file?'
read*,outfile

 open (1, file=filename1, form='unformatted')
 read (1,iostat=ioer) nbod1,nsph1,nstar1
   if(ioer) then 
    rewind(1)
    read (1,iostat=ioer) nbod1
    nsph1=0
    nstar1=0
   endif
 print*, 'file1 has:',nbod1,nsph1,nstar1

 open (2, file=filename2, form='unformatted')
 read (2,iostat=ioer) nbod2,nsph2,nstar2
   if(ioer) then 
    rewind(2)
    read (2,iostat=ioer) nbod2
    nsph2=0
    nstar2=0
   endif
 print*, 'file2 has:',nbod2,nsph2,nstar2

 open (3, file=outfile, form='unformatted')
 write(3), nbod1+nbod2,nsph1+nsph2,nstar1+nstar2

 do i=1,nsph1
  read(1) pmass,x,v
  write(3) pmass,x,v
 enddo
 do i=1,nsph2
  read(2) pmass,x,v
  write(3) pmass,x,v
 enddo
 do i=1,nbod1-nsph1-nstar1
  read(1) pmass,x,v
  write(3) pmass,x,v
 enddo
 do i=1,nbod2-nsph2-nstar2
  read(2) pmass,x,v
  write(3) pmass,x,v
 enddo
 do i=1,nstar1
  read(1) pmass,x,v
  write(3) pmass,x,v
 enddo
 do i=1,nstar2
  read(2) pmass,x,v
  write(3) pmass,x,v
 enddo

 close(1)
 close(2)
 close(3)

end program

! declaration of large arrays
module memMod

public
private :: ndim,nsubcell

  integer, parameter :: ndim=3, nsubcell=2**ndim

! srlist: threadprivate array for search results
! bodlist: threadprivate integer array of treewalk results
! tempvect: threadprivate real array, scratch space
! templist: temporary integer array
!
! rest is cell or body data

  integer, allocatable :: bodlist(:),cellstart(:),  &
    itimestp(:),nbexist(:),npercell(:),order_bodlist(:),  &
    otimestp(:),pactive(:),srlist(:),pshape(:),subp(:,:),templist(:)

  real, allocatable :: aacc(:),acc(:,:),bottom(:,:),cellsize(:),csound(:),  &
    derad(:),drhodh(:),elecfrac(:),epsgrav(:),  &
    esnthdt(:),fuvheat(:),h2frac(:),hsmcurlv(:),  &
    hsmdivv(:),hsmooth(:),mass(:),mumaxdvh(:),oldderad(:),phi(:),  &
    phiext(:),pos(:,:),quad(:,:),rho(:),snentropy(:),starfuv(:),  &
    tcollaps(:),temperat(:),tempvect(:),tfeedb(:),tform(:),tvel(:),  &
    vdisp(:),vel(:,:),veltpos(:,:)
    
  real, allocatable, target :: ethermal(:),ethold(:),dethdt(:),dethold(:)
  real, pointer :: entropy(:),entold(:),dentdt(:),dentold(:)

!$omp threadprivate(bodlist,srlist,tempvect)

  integer :: ppropcount, pordercount, treestatecount, sphtreecount
      ! ppropcount -> +1 if particle prop changed
      ! (mass,pos,epsgrav,starfuv,hsmooth)
      ! pordercount -> +1 particle order changed

! AMUSE, AVE 26-Mar-2012
! list of removed ids during the evolve loop
! nremovals will be set to zero at start of the run
    integer, allocatable :: removedidssph(:)
    integer nremovals
! ---
 contains

 subroutine initmem(nbodsmax,nsphmax,ncells)
  integer nbodsmax,nsphmax,ncells
  integer nbods1,nbodcell

  nbods1=nbodsmax+1
  nbodcell=nbodsmax+ncells


 allocate( &
   cellstart(nbods1:nbodcell),  &
   itimestp(1:nbodsmax),  &
   nbexist(1:nbodsmax),  &
   npercell(nbods1:nbodcell),  &
   order_bodlist(1:nbodsmax),  &
   otimestp(1:nbodsmax),  &
   pactive(1:nbodsmax),  &
   pshape(nbods1:nbodcell),  &
   subp(nbods1:nbodcell,1:nsubcell),  &
   templist(1:nbodsmax), &
   removedidssph(1:nbodsmax) & ! AMUSE, allocated list to store the id's
 )
 allocate( &
   aacc(1:nbodsmax), &
   acc(1:nbodsmax,1:ndim),  &
   bottom(nbods1:nbodcell,ndim),  &
   cellsize(nbods1:nbodcell),  &
   csound(1:nsphmax),  &
   derad(1:nsphmax),  &
   dethdt(1:nsphmax),  &
   dethold(1:nsphmax), &
   drhodh(1:nsphmax),  &
   elecfrac(1:nsphmax),  &
   epsgrav(1:nbodcell),  &
   esnthdt(1:nsphmax),  &
   ethermal(1:nsphmax),  &
   ethold(1:nsphmax),  &
   fuvheat(1:nbodsmax),  &
   h2frac(1:nsphmax),  &
   hsmcurlv(1:nsphmax),  &
   hsmdivv(1:nsphmax),  &
   hsmooth(1:nbodcell),  &
   mass(1:nbodcell),  &
   mumaxdvh(1:nsphmax),  &
   oldderad(1:nsphmax),  &
   phi(1:nbodsmax),  &
   phiext(1:nbodsmax),  &
   pos(1:nbodcell,1:ndim),  &
   quad(nbods1:nbodcell,1:2*ndim-1),  &
   rho(1:nsphmax),  &
   snentropy(1:nbodsmax),  &
   starfuv(1:nbodcell),  &
   tcollaps(1:nsphmax),  &
   temperat(1:nsphmax),  &
   tfeedb(1:nbodsmax),  &
   tform(1:nbodsmax),  &
   tvel(1:nbodsmax),  &
   vdisp(1:nsphmax),  &
   vel(1:nbodsmax,1:ndim),  &
   veltpos(1:nsphmax,1:ndim) &
 )

!$ call omp_set_dynamic(.FALSE.)

!$omp parallel
 allocate( &
   tempvect(1:nbodsmax+nsphmax),  &
   bodlist(1:nbodsmax),  &
   srlist(1:nbodcell) &
 )
!$omp end parallel

 entropy=>ethermal
 entold=>ethold
 dentdt=>dethdt
 dentold=>dethold

 ppropcount=0
 pordercount=0
 treestatecount=-1
 sphtreecount=-1
 
 end subroutine
 
end module 

! simple code for random number sequences
! from numerical recipes..
function ranfb(ix)
  real :: y,ranfb
  integer :: ix,ix1,ix2,ia1,ia2,ic,j1,j2,j3

  ia1=273
  ia2=25301
  ic=226908345
  
  if (ix.lt.0) ix=-ix
  if (ix.gt.2**30) ix=MOD(ix,2**30)

  ix1=ix/(2**15)
  ix2=ix-ix1*(2**15)
  j1=MOD(ix1*ia2,2**15)*2**15
  j2=MOD(ix2*ia1,2**15)*2**15
  j3=ix2*ia2
  ix=MOD(j1+j2,2**30)
  ix=MOD(ix+j3,2**30)
  ix=MOD(ix+ic,2**30)
  y=FLOAT(ix)

  ranfb=y/2**30

end function

subroutine setRND
  include 'globals.h'
  integer i
  real ranfb
  do i=1,nrndtable
    rndtable(i)=ranfb(rnseed)
  enddo
end subroutine

function pRND(i)
  include 'globals.h'
  real :: pRND
  integer :: i
  pRND=rndtable(mod(i,nrndtable)+1)
end function

program sfrinfo
 integer :: ig,is,i,ioerror
 real :: pos(3),vel(3),rho,temp,xe,fuv,h2,smass,gmass,time
 character :: filename*80
 
 print*,' sf history file?'
 read*, filename
 
 open(unit=20,file=trim(filename)//'.sfh',status='OLD',IOSTAT=ioerror)
 if(ioerror.NE.0) then
  print*,' file error'
  stop
 endif
 
10 read(20,*,IOSTAT=ioerror) ig,is
   if(ioerror.EQ.0) then
    read(20,*) time
    read(20,*) pos
    read(20,*) vel
    read(20,*) rho
    read(20,*) temp
    read(20,*) xe
    read(20,*) fuv
    read(20,*) h2
    read(20,*) smass,gmass
    
    write(*,5),time,rho,h2,xe
    
    goto 10
   endif
  close(20)
5 format( e12.4,' ',e12.4,' ',e12.4,' ',e12.4)


end program

subroutine evaluate_tidalfield(peps,ppos,ptide)
 include 'globals.h'
 real,intent(in) :: ppos(3),peps
 real,intent(inout) :: ptide(6)
 
 ptide(1:6)=0
 if(selfgrav) call system_tidalfield(peps,ppos,ptide)
 if(fixthalo) call halotidalfield(ppos,ptide)

end subroutine

subroutine system_tidalfield(peps,ppos,ptide)
 include 'globals.h'
 real,intent(in) :: ppos(3),peps
 real,intent(inout) :: ptide(6)
 integer i,nterms
! periodic - 
  if(.NOT.directsum) then
   nterms=0
   call treewalk(root,ppos,peps,0.,0.,nterms)
  else
   nterms=nbodies
   do i=1,nbodies
    bodlist(i)=i
   enddo
  endif 
  call tidalsum(peps,ppos,ptide,nterms)
end subroutine

subroutine tidalsum(peps,ppos,ptide,nterms)
 include 'globals.h'
 integer, intent(in):: nterms
 real,intent(in) :: peps,ppos(3)
 real,intent(inout):: ptide(6)
 real :: dx,dy,dz,dist2,dist,epseff,epseffi,drdeldrg, &
  &  rinveff,r3inveff,r5inveff,drsm,rhinv
 integer :: i,q,smindex
 do i=1,nterms
   q=bodlist(i)
   dx=ppos(1)-pos(q,1)
   dy=ppos(2)-pos(q,2)
   dz=ppos(3)-pos(q,3)
   dist2=dx*dx+dy*dy+dz*dz
   dist=SQRT(dist2)     
   epseff=peps+epsgrav(q)  
   if(dist.GE.epseff) then
    rinveff=1./dist
    r3inveff=rinveff**3
    r5inveff=rinveff**5
   else
    epseffi=1./epseff
    rhinv=dist*epseffi
    if(rhinv.LT.0.5) then
      r3inveff=4./3.+rhinv**2*(4.*rhinv-4.8)
      r5inveff=12*rhinv-9.6
    else
      r3inveff=8./3.-6.*rhinv+4.8*rhinv**2- &
            4./3.*rhinv**3-1./120./rhinv**3
      r5inveff=9.6-4.*rhinv-6./rhinv+1./40./rhinv**5
    endif   
    r3inveff=r3inveff*8*epseffi**3
    r5inveff=-r5inveff*8./3.*epseffi**5
   endif

   ptide(1)=ptide(1)+mass(q)*(-r3inveff+3*r5inveff*dx**2)              
   ptide(4)=ptide(4)+mass(q)*(-r3inveff+3*r5inveff*dy**2)              
   ptide(6)=ptide(6)+mass(q)*(-r3inveff+3*r5inveff*dz**2)              
   ptide(2)=ptide(2)+mass(q)*3*r5inveff*dx*dy              
   ptide(3)=ptide(3)+mass(q)*3*r5inveff*dx*dz              
   ptide(5)=ptide(5)+mass(q)*3*r5inveff*dy*dz              

   if(usequad.AND.q.GE.nbods1) then
    call terror("tide+quad tbd")
   endif

 enddo
end subroutine tidalsum

! module for cooling
! usage: 
!  - include module "use CoolingMod"
!  - initialization by calling InitCooling once with directory of data files
!  - call Coolfunc(ne,T) 
!  - call EndCooling when done
! (see test program at the end for example)
! uses module Elementsmod 

module CoolingMod
 implicit none
 private
 public :: InitCooling, Coolfunc,ElementCool,ElementCoolFunc,EndCooling
 
 public :: Cool_nelements

  logical, parameter :: dbg=.FALSE.
  integer, parameter :: coolTableLength=160
  real, parameter :: logTmin=1,logTmax=9,dlogT=0.05
  real, parameter :: amu=1.6605e-24

  integer, save :: nelements
  integer, save :: H,He,C
  integer, save :: Cool_nelements
  real, save :: meanmwt
  real, save :: coolUnit=1.
  
  real,  allocatable, save :: abundances(:)
  real,  allocatable, save :: weights(:)
  real,  allocatable, save :: fractions(:), wfractions(:)
  real,  allocatable, save :: coolTemp(:), coolTable(:,:), coolTable2(:,:)
  character(len=4),dimension(:), allocatable, save :: elementnames
  character(len=200),save :: datadir
  
 contains
 
  subroutine EndCooling
   integer :: test
   deallocate(abundances,weights,fractions, elementnames, &
              wfractions,coolTemp,coolTable,coolTable2,STAT=test)
   if(test.NE.0) call CoolError(99)
  end subroutine EndCooling
 
  subroutine InitCooling(indatadir)
  use ElementsMod
  integer :: i,test
  character(len=200) :: indatadir
 
   datadir=indatadir
   if(allocated(abundances)) call EndCooling

   call InitElements
   nelements=nelementsQ()
   Cool_nelements=nelements
   if(nelements.LE.0) call CoolError(0)
  
   allocate(abundances(nelements),weights(nelements),fractions(nelements), &
            wfractions(nelements),coolTemp(coolTableLength), &
            coolTable(nelements,coolTableLength),elementnames(nelements), &
            coolTable2(nelements,coolTableLength),STAT=test)
   if(test.NE.0) call CoolError(1)

   H=elementnrQ("H   ")
   He=elementnrQ("He  ")
   C=elementnrQ("C   ")
   if(H.EQ.0.OR.He.EQ.0.OR.C.EQ.0) call CoolError(2)
   
   abundances=abundancesQ()
   weights=weightsQ()
   fractions=fractionsQ()
   meanmwt=meanmwtQ()
   wfractions=wfractionsQ()   
   call elementnamesQ(elementnames)
   
   coolTable=-50.
   coolTable2=-50.
   do i=1,nelements
    call ReadCool(i)
   enddo

  coolTemp=10**coolTemp
  coolTable=10**coolTable
  coolTable2=10**coolTable2

 end subroutine InitCooling
  
  
  subroutine ReadCool(i)
   integer :: i,j,jmax
   character(len=215) :: filename
   
   filename=trim(datadir)//trim(elementNames(i))//'.cool'
   if(dbg)print*,filename
   open(unit=19,file=filename,status='OLD')
    read(19,*) jmax
    do j=1,jmax
      read(19,*) coolTemp(j),coolTable(i,j)
   if(dbg) print*,coolTemp(j),coolTable(i,j)
    enddo
   close(19)    
   
   filename=trim(datadir)//trim(elementNames(i))//'.Hcool'
   if(dbg) print*,filename
   open(unit=19,file=filename,status='OLD')
    read(19,*) jmax
    do j=1,jmax
      read(19,*) coolTemp(j),coolTable2(i,j)
   if(dbg) print*,coolTemp(j),coolTable2(i,j)
    enddo
   close(19)    
     
  end subroutine ReadCool
  
  function ElementCool(ne,T,elem)
   real :: ElementCool,HElementCool
   real,intent(in) ::ne,T
   integer,intent(in) :: elem
   real :: dt,logT
   integer :: ti,ti1,ti2
   
   if(dbg) then
    if(ne.LT.0) call coolError(1)
    if(T.LT.10**logTmin.OR.T.GT.10**logTmax) call coolError(1)
   endif
   
   logT=log10(T)
   ti=(logT-logTmin)/dlogT+1
   ti1=max(ti,1);ti1=min(coolTableLength-1,ti1)
   dt=(T-coolTemp(ti1))/(coolTemp(ti1+1)-coolTemp(ti1))
   ElementCool=(1.-dt)*coolTable(elem,ti1)+dt*coolTable(elem,ti1+1)
   HElementCool=(1.-dt)*coolTable2(elem,ti1)+dt*coolTable2(elem,ti1+1)
   ElementCool=ne*ElementCool    
   ElementCool=ElementCool+HElementCool

  end function ElementCool
  
  function ElementCoolFunc(ne,T,elem,chm)
   real :: ElementCoolFunc
   real,intent(in) ::ne,T
   integer,intent(in) :: elem
   real,intent(in), optional ::chm(1:nelements)
   real :: chem(1:nelements)
   
   if(.not.present(chm)) then 
    chem=abundances
   else
    chem=chm
   endif 
   
   ElementCoolFunc=ElementCool(ne,T,elem)*chem(elem)* &
    (fractions(H)/meanmwt/amu)**2*coolUnit
  end function ElementCoolFunc

  
  
  function xeCool(T,chm)
   real :: xeCool
   real,intent(in) ::T
   real,intent(in), optional ::chm(1:nelements)
   real :: dt,logT,coolinterp(1:nelements),chem(1:nelements)
   integer :: ti,ti1,ti2
   
   if(.not.present(chm)) then 
    chem=abundances
   else
    chem=chm
   endif 
   
   if(dbg) then
    if(T.LT.10**logTmin.OR.T.GT.10**logTmax) call coolError(1)
   endif
   
   logT=log10(T)
   ti=(logT-logTmin)/dlogT+1
   ti1=max(ti,1);ti1=min(coolTableLength-1,ti1)
   dt=(T-coolTemp(ti1))/(coolTemp(ti1+1)-coolTemp(ti1))
   coolinterp=(1.-dt)*coolTable(1:nelements,ti1)+dt*coolTable(1:nelements,ti1+1)
   xeCool=sum(chem*coolinterp)    
  end function xeCool
  
  function HCool(T,chm)
   real :: HCool
   real,intent(in) :: T
   real,intent(in), optional ::chm(1:nelements)
   real :: dt,logT,coolinterp(1:nelements),chem(1:nelements)
   integer :: ti,ti1,ti2
   
   if(.not.present(chm)) then 
    chem=abundances
   else
    chem=chm
   endif 
   
   if(dbg) then
    if(T.LT.10**logTmin.OR.T.GT.10**logTmax) call coolError(1)
   endif
   logT=log10(T)
   ti=(logT-logTmin)/dlogT+1
   ti1=max(ti,1);ti1=min(coolTableLength-1,ti1)
   dt=(T-coolTemp(ti1))/(coolTemp(ti1+1)-coolTemp(ti1))
   coolinterp=(1.-dt)*coolTable2(1:nelements,ti1)+dt*coolTable2(1:nelements,ti1+1)
   HCool=sum(chem*coolinterp)    
  end function HCool
  
  function CoolFunc(ne,T,chm)
   real :: CoolFunc
   real,intent(in) :: ne,T
   real,intent(in), optional ::chm(1:nelements)
   real :: Tl
   Tl=T 
   if(Tl.LT.10**logTmin) Tl=10**logTmin
   if(.not.present(chm)) then
    CoolFunc=ne*xeCool(Tl)+HCool(Tl)   ! not ok. but for low ne
    CoolFunc=(fractions(H)/meanmwt/amu)**2*CoolFunc*coolUnit 
   else
    CoolFunc=ne*xeCool(Tl,chm)+HCool(Tl,chm)   ! not ok. but for low ne
    CoolFunc=(fractions(H)/meanmwt/amu)**2*CoolFunc*coolUnit 
   endif
  
  end function CoolFunc
  
!  function H2Cool(T) result(x)
!   real :: x,T
!   real,parameter :: rop=1.5
!      
!   x=4.77e-26/(1+rop)*(exp(-510/T)+1.35*rop*exp(-845/T))   

!  end function
  
!  function H2CoolFunc(ne,T,h2frac) result(x)
!   real :: x
!   real,intent(in) :: ne,T,h2frac
!   real :: Tl
!   Tl=T 
!   if(Tl.LT.10**logTmin) Tl=10**logTmin
!   x=ne*xeCool(Tl)+ &
!      (1-h2frac)*HCool(Tl)+h2frac*H2Cool(Tl)    ! not ok. but for low ne
!   x=(fractions(H)/meanmwt/amu)**2*x*coolUnit 
!  end function

  
  subroutine coolError(i)
   integer i
   
   print*,'cool error:',i
   stop
   
  end subroutine 
   
 end module CoolingMod


! program test
! use ElementsMod 
! use CoolingMod
! character(len=200) :: indatadir
! real :: temp
! call InitElements
! indatadir="/home/pelupes/fish/stars/data/"
! call InitCooling(indatadir)

! print*,0.01*xecool(2000.)/elementcool(0.01,2000.,8)

!10 read*, temp
! if(temp.eq.0) stop
! print*,temp,Coolfunc(0.1,10**temp)
!goto 10 
! write(*,5),temp, xecool(temp),HCool(temp),H2cool(temp)
!goto 10 
!5 format( e12.4,' ',e12.4,' ',e12.4,' ',e12.4)
! end program test

subroutine initdump(n)
  use fixedhalomod
  use ElementsMod
  use CoolingMod
  use IonMod
  use MoleculeMod
  use H2CoolMod
  use StarsMod
  include 'globals.h' 
  integer n

  pordercount=pordercount+1
  ppropcount=ppropcount+1
  call readdump(n)
  call set_parameters(1)
  call initfixedhalo(poshalo,trim(datadir)//halofile)
  if(masshalo.NE.fixedhalomass) call terror('halo reinit error')

  call heattabel

  if(usepm) then
    if(verbosity.GT.0) print*,' ...initPM...'
    call initpm 
  endif
  call outstate(n)      
end subroutine

subroutine initpm
  use pmgravMod
  include 'globals.h' 
  integer i
  real r,bmin(3),bmax(3)
   
  bmin=-hboxsize
  bmax=hboxsize 
  call pmgravInit(npm, bmin, bmax)
   
  tpm=tnow
  rcut=rcutQ()
  rcut2=rcut**2
  pmsoft=softQ()
  pmdr=ninterp/rcut2      
  do i=0,ninterp
    r=1/pmsoft*sqrt(real(i)/pmdr)
    pmpot(i)=ficorrect(r)
    pmacc(i)=forcecorrect(r)
  enddo
  pmpot(ninterp+1)=0 
  pmacc(ninterp+1)=0 
  if(verbosity.GT.0) write(*,'("  > pm box, rcut, rsoft:", 3f8.2)') &
    pboxsize,sqrt(rcut2),pmsoft
end subroutine

subroutine inithalo
  use fixedhalomod                 
  include 'globals.h'
  
  if(halofile.EQ.'none'.OR.halofile.EQ.'NONE'.OR. &
    halofile.EQ.'None') then
    fixthalo=.FALSE.
    return
  endif

  print*,' ...dark halo...'
  poshalo=0.
  call initfixedhalo(poshalo,trim(datadir)//halofile)
  masshalo=fixedhalomass
end subroutine

subroutine initeps
  include 'globals.h'
  integer i,j,low
  real epsavg
  if(adaptive_eps.OR.eps.EQ.0) then
    if(usesph) then
      call seteps('coll')
    else
      call seteps('all ')
    endif

    if(adaptive_eps) then
      return
    else 
      epsavg=0.
      low=1
      if(usesph.AND.nbodies.GT.nsph) low=1+nsph
      do i=low,nbodies
        epsavg=epsavg+epsgrav(i)
      enddo
      epsavg=epsavg/(nbodies-low+1)
    endif
  else
    epsavg=eps
  endif
  
  if(eps.EQ.0) eps=epsavg  ! eps in snapshot      
  epsgrav(nsph+1:nbodies)=epsavg

  if(.not.usesph) epsgrav(1:nsph)=epsavg

end subroutine

subroutine initrnd
  include 'globals.h'   
  rnseed=initialseed
  call setRND
end subroutine

subroutine initpars
  use ElementsMod
  include 'globals.h'
  integer p,i
  real deldr2,xw,xw2,deldrg,xw3,xw4

  if(verbosity.GT.0) print*,' ...initpars...'

  nsnap=firstsnap

  call initrnd

  radiate=radiate.AND.usesph
  starform=starform.AND.usesph

  tiny=1.e-20

  gamma1=gamma-1.
  if(gamma.EQ.1.) gamma1=1.

  heat_par1=heat_par1*3.46e14*unitl_in_kpc**2.5/unitm_in_msun**1.5
  heat_par2=heat_par2*2.34e-17/SQRT(unitl_in_kpc*unitm_in_msun)
  cool_par=cool_par*2.34e-17/SQRT(unitl_in_kpc*unitm_in_msun)
  mhboltz=1.211e-8
  mhboltz=mhboltz*4.30e4*unitm_in_msun/unitl_in_kpc
!  mhboltz=mhydrogen/kboltz*4.30e4*unitm_in_msun/unitl_in_kpc
  mumhkbol=meanmwt*mhboltz
  mumhkgam=meanmwt*mhboltz/gamma
  mumhkg1=meanmwt*mhboltz*gamma1
  if(radiate) graineff=graineff*zQ()/solarzQ()     
  
  heatconst=2.0693e14*unitl_in_kpc**2.5/unitm_in_msun**1.5
!  nsconst: rho-> H nr dens  (strictly speaking fhydrogn = f_H/meanmwt)
  densconst=4.078e-8*fhydrogn*unitm_in_msun/unitl_in_kpc**3
  timescale=1.488e19*unitl_in_kpc*sqrt(unitl_in_kpc/unitm_in_msun)
  lengthscale=3.086e21*unitl_in_kpc
  velscale=lengthscale/timescale
  flxscale=-41.282-2.*alog10(unitl_in_kpc)
  massscale=1.989e33*unitm_in_msun

  tsnbeg=tsnbeg*year/timescale
  tbubble=tbubble*year/timescale
!  snenergy=nsupernova*esupernova*unitl_in_kpc/(unitm_in_msun*unitm_in_msun)
  snenergy=unitm_in_msun*nsupernova* &
    (esupernova/1.e51)*1.1695e13*unitl_in_kpc/(unitm_in_msun*unitm_in_msun)
 
  tcollfac=tcollfac*sfeff
  masscrit=masscrit/unitm_in_msun
     
  hboxsize=0.5*pboxsize

  if(periodic.AND.selfgrav) then
    call terror('periodic tb fixed ')
  endif

  deldr2=4./ninterp
  deldr2i=1./deldr2

  do i=0,1+ninterp
    xw2=i*deldr2
    xw=SQRT(xw2)
    if(xw2.LE.1.) then
      wsmooth(i)=1.-1.5*xw2+0.75*xw*xw2
      dwsmooth(i)=-3.+2.25*xw
    else
      wsmooth(i)=0.25*(2.-xw)**3
      dwsmooth(i)=-0.75*(2.-xw)**2/(xw+tiny)
    endif
    if(xw2.GE.4) then
      wsmooth(i)=0.
      dwsmooth(i)=0.
    endif
  enddo

  deldrg=2./ninterp

  if(radiate) call rdintpol

end subroutine

subroutine initpos
  include 'globals.h'
  integer i

  call activateparts
  call corrpos(itimestp,'desync')
  otimestp(pactive(1:npactive))=itimestp(pactive(1:npactive))
end subroutine

subroutine smoothall
  include 'globals.h'

  call terror(' TBD smoothing')
    
end subroutine

subroutine inittimestep
  include 'globals.h'
  active_bin=0
  npactive=0
  nsphact=0
end subroutine

subroutine activateparts
  include 'globals.h'
  integer i

  active_bin=0
  npactive=nbodies
  do i=1,npactive
    pactive(i)=i
  enddo

  if(usesph) then
    nsphact=nsph
  else
    nsphact=0
  endif

end subroutine

subroutine initsys
  include 'globals.h'
  integer ij
  real rtime

  call set_parameters(0)

  call startout

  call heattabel

  call initpars

  call inithalo

  if(periodic.and.selfgrav) call initbc

  if(radiate) call initnewstar

  call readbods(inputfile)

  if(usepm) then
    if(verbosity.GT.0) PRINT*,' ...initPM...'
    call initpm 
  endif
          
  call postprocessread

  call initpos

  call inittimestep
                          
  call outstate(0)

end subroutine

subroutine ethdotinit   
  include 'globals.h'
   
  if(sph_visc.EQ.'bulk') call terror(' bulk visc. not implemented ')
           
  if(.NOT.uentropy) then          
    call alldethacc
  else
    call alldentacc
  endif
          
end subroutine

subroutine initepsgas
  include 'globals.h' 
  integer i
  real hsmthavg

  if(epsgas.GT.0) then
    do i=1,nsph
      epsgrav(i)=epsgas
    enddo
    return
  endif
  if(eps.GT.0) then
    do i=1,nsph
      epsgrav(i)=eps
    enddo
    return
  endif
  call seteps('sph ')
  hsmthavg=0.
  do i=1,nsph
    hsmthavg=hsmthavg+epsgrav(i)
  enddo
  hsmthavg=hsmthavg/nsph
  do i=1,nsph
    epsgrav(i)=hsmthavg
  enddo    
end subroutine

subroutine rdintpol 
  include 'globals.h'
  integer i,ioerror
  real dummy
!  waardes van de spline soft. (als functie van (r/eps)^2, voor 0+1/ninter2-4)

!  lees uvpot in: spline soft tabel voor uv flux
!  nb: uv interpolatie gaat tot grotere r!

  open(UNIT=uvfilenr,file=trim(datadir)//uvfile, status='OLD',iostat=ioerror)
  if(ioerror.NE.0) then
    print*,' stop -- data file error:',uvfile       
    print*,' please check directory:',datadir
  endif   
  do i=1,uvinterp
    read(uvfilenr,*)dummy,smoothuv(i)
  enddo        
  close(uvfilenr)

  smoothuv(0)=1
  do i=0,uvinterp
    smoothuv(i)=smoothuv(i)*3       
  enddo
end subroutine

subroutine nbexistinit
  include 'globals.h'
  integer i
   
  totptag=nbodies         
  do i=1,nbodies
    nbexist(i)=i
  enddo  
end subroutine

subroutine initbc
  call terror('not implemented')
end subroutine

subroutine seteps(option)
  character(len=4) :: option
  real :: epsold

  call setbox(option)
  call loadtree5(option,0)
  call epscal(option)
end subroutine

subroutine epscal(option)
  include 'globals.h'
  character(len=4) :: option
  integer :: low,up,p,inear
  real :: position(3),hsearch,getlocalscale

  select case (option)
  case('all ')
    low=1;up=nbodies
  case('sph ')
    low=1;up=nsph
  case('star')
    low=nbodies-nstar+1;up=nbodies
  case('coll')
    low=nsph+1;up=nbodies
  case default
    low=1;up=nbodies
  end select

  nstot=0
  nsmin=nbodies
  nsmax=0

  if(low.GT.up) return
  if(up-low.LE.targetnn) then
    epsgrav(low:up)=rsize/2
    return
  endif    

!$omp parallel do private(p,position,hsearch,inear) &
!$omp reduction(+ : nstot) &
!$omp reduction(min : nsmin) &
!$omp reduction(max : nsmax)
  do p=low,up
    position=pos(p,1:3)
    if(.not.adaptive_eps.or.epsgrav(p).eq.0) then
      hsearch=getlocalscale(position)
    else
      hsearch=epsgrav(p)
    endif  
    call nnscalefix(position,hsearch,inear,targetnn,nn_tol,root)
    epsgrav(p)=hsearch
    nstot=nstot+inear
    nsmax=MAX(nsmax,inear)
    nsmin=MIN(nsmin,inear)
  enddo
  nsavg=nstot/(up-low+1)

  if(verbosity.GT.0) print*,'<epscal> mn,av,mx:',nsmin,nsavg,nsmax

end subroutine

subroutine hsmcal
  include 'globals.h'
  character(len=4) :: option
  integer :: low,up,p,inear
  real :: position(3),hsearch,getlocalscale

  low=1;up=nsph

  nntot=0
  nnmin=nbodies
  nnmax=0

  if(low.GT.up) return

!$omp parallel do private(p,position,hsearch,inear) &
!$omp reduction(+ : nntot) &
!$omp reduction(min : nnmin) &
!$omp reduction(max : nnmax)
  do p=low,up
    position=pos(p,1:3)
    if(hupdatemethod.EQ.'none'.or.hsmooth(p).le.0) then
      hsearch=getlocalscale(position)
    else
      hsearch=hsmooth(p)
    endif  
    call nnscalefix(position,hsearch,inear,nsmooth,nsmtol,root)
    hsmooth(p)=hsearch
    nntot=nntot+inear
    nnmax=MAX(nnmax,inear)
    nnmin=MIN(nnmin,inear)
  enddo
  nnavg=nntot/(up-low+1)
  if(verbosity.GT.0) print*,'<hsmcal> mn,av,mx:',nnmin,nnavg,nnmax

end subroutine


subroutine nnscalefix(position,hsearch,inear,ntarget,ntol,rt)
  include 'globals.h'
  real,dimension(3),intent(in) :: position
  real, intent(in) :: ntol
  real, intent(inout) :: hsearch
  integer, intent(in) :: ntarget,rt 
  integer,intent(inout) :: inear

  if(hsearch.le.0) call terror('nnscalefix error 1')
  inear=0
  do while(inear.LT.ntarget)
    if(hsearch.GT.rsize) call terror('nnscalefix error 2')
    inear=0
    call search_d2(rt,2*hsearch,position,inear,srlist,tempvect)
    if(inear.GE.(1.-ntol)*ntarget.AND.inear.LE.(1.+ntol)*ntarget) return
    hsearch=hsearch*1.3
  enddo
 
  call mrgrnk(inear,tempvect,srlist) ! srlist can be overwritten  
  hsearch=SQRT(tempvect(srlist(ntarget)))/2.
  inear=ntarget
 
end subroutine nnscalefix

function getlocalscale(spos) result(scale)
  include 'globals.h'
  real :: spos(3),lpos(3),upos(3),scale,dist2box
  integer :: daughter,subind,subcellindex2,id

  lpos=bottom(root,1:3)
  upos=bottom(root,1:3)+rsize
  scale=dist2box(spos,lpos,upos)
  
  if(scale.EQ.0) then
    daughter=root
    scale=rsize
    id=1
    do while(daughter.GT.nbodsmax) 
      scale=scale/2
      lpos=bottom(daughter,1:3)+cellsize(daughter)/2.
      subind=subcellindex2(lpos,spos)
      subind=peanovalue(subind,id)
      daughter=subp(daughter,subind)
      id=pshapefromp(subind,id)
    enddo
  else
    scale=sqrt(scale+rsize**2/1.e5) 
  endif 
end function getlocalscale

function dist2box(spos,lpos,upos) result(dist2)
  real :: spos(3),lpos(3),upos(3),dist2
  integer :: k
 
  dist2=0
 
  do k=1,3
    if(spos(k).LT.lpos(k)) then
      dist2=dist2+(lpos(k)-spos(k))**2
    else
      if(spos(k).GT.upos(k)) then
        dist2=dist2+(upos(k)-spos(k))**2
      endif
    endif
  enddo
end function
